#383 Div1 Problem B Arpa's weak amphitheater.... (分组背包 && 并查集)

题意 : 有n个人,每个人都有颜值bi与体重wi。剧场的容量为W。有m条关系,xi与yi表示xi和yi是好朋友,在一个小组。 每个小组要么全部参加舞会,要么参加人数不能超过1人。 问保证总重量不超过W,剧场中的颜值最大能到多少?

分析 : 很显然的分组背包题目, 不过有所不同, 先来回顾一下普通的分组背包的描述 给出一个背包,背包有容量C,再给出N组物品,每组物品有ki种,每种物品有对应的体积Vi,价值Pi,每组物品至多选一种,且最多取一件。求用背包装物品,能获得的最大总价值是多少。可以发现和上面的不同之处就是多了一个可以全取的操作, 其实只要再在每一组里面加上所有的物品和就行了, 便成了一道普通的模板题了!在分组的时候使用简单的并查集即可!

瞎搞:在实现的时候很慢, 还老是犯小错误, 归其原因就是分组背包接触太少, 即使是模板题也写的有点不流利!

#include<bits/stdc++.h>
using namespace std;
struct st
{
    int w, v, id;
};
st arr[1001];
int v[1001][1001], w[1001][1001], dp[1001], p[1001];///p数组表示各个组里面的物品个数
int sumv[1001], sumw[1001];
int c[1001];
map<int, int> M;
int findset(int x)
{
    int root = x;
    while(c[root] != root) root = c[root];
    int j;
    while(c[x] != root){
        j = c[x];
        c[x] = root;
        x = j;
    }
    return root;
}
inline int join(int a, int b)
{
    int f = findset(a), ff = findset(b);
    if(f != ff){
        c[f] = ff;
    }
}
#define IN 0
#define OUT 0
int main(void)
{
    #if IN
        freopen("in.txt", "r", stdin);
    #endif
    #if OUT
        freopen("out.txt", "w", stdout);
    #endif
    int n, m, C;
    scanf("%d%d%d", &n, &m, &C);
    M.clear();
    for(int i=0; i<=n; i++){
        memset(v[i], 0, sizeof(v[i]));
        memset(w[i], 0, sizeof(w[i]));
        memset(p, 0, sizeof(p));
        memset(dp, 0, sizeof(dp));
        memset(sumw, 0, sizeof(sumw));
        memset(sumv, 0, sizeof(sumv));
        arr[i].id = i;//忽略这个id, 没有用, 懒得改了.....
        c[i] = i;
    }
    for(int i=1; i<=n; i++) scanf("%d", &arr[i].w);
    for(int i=1; i<=n; i++) scanf("%d", &arr[i].v);
    for(int i=0; i<m; i++){
        int a, b;
        scanf("%d%d", &a, &b);
        join(a, b);
    }
    int top = 0;///表示组数
    bool vis[1001];
    memset(vis, true, sizeof(vis));
    for(int i=1; i<=n; i++){
        int temp = findset(i);
        if(vis[temp]){///如果还没有出现过这个在并查集里面的“大佬”
            M[temp] = top;//记录一下老大所在的组的下标元素
            vis[temp] = false;
            v[top][p[top]] = arr[i].v;
            w[top][p[top]] = arr[i].w;
            sumv[top] += arr[i].v;
            sumw[top] += arr[i].w;
            p[top]++, top++;
        }else{
            int Top = M[temp];
            v[Top][p[Top]] = arr[i].v;
            w[Top][p[Top]] = arr[i].w;
            sumv[Top] += arr[i].v;
            sumw[Top] += arr[i].w;
            p[Top]++;
        }
    }
    for(int i=0; i<top; i++){
        if(p[i]==1) continue;//这里需要注意, 只有一个元素的时候, 不应该再加所有元素的和, 会重复的!
        v[i][p[i]] = sumv[i];
        w[i][p[i]] = sumw[i];
        p[i]++;
    }
///Debug begin
//    printf("top = %d\n", top);
//    for(int i=0; i<top; i++){
//        printf("In group %d\n", i);
//        printf("v");puts("");
//        for(int j=0; j<p[i]; j++){
//            printf("ord=%d, v=%d\n", j, v[i][j]);
//        }
//        printf("w");puts("");
//        for(int j=0; j<p[i]; j++){
//            printf("ord=%d, w=%d\n", j, w[i][j]);
//        }
//        puts("");
//    }
//    puts("");
///Debug end
    for(int i=0; i<top; i++){
        for(int j=C; j>=0; j--){
            for(int k=0; k<p[i]; k++){
                if(w[i][k] <= j)
                dp[j] = max(dp[j], dp[j-w[i][k]]+v[i][k]);
            }
        }
///Debug begin
//        for(int ii=1; ii<=C; ii++){
//            printf("%d ", dp[ii]);
//        }
//        puts("");
///Debug end
    }
    printf("%d\n", dp[C]);
    return 0;
}

#383 Div1 Problem B Arpa's weak amphitheater.... (分组背包 && 并查集)

时间: 2024-12-19 04:37:33

#383 Div1 Problem B Arpa's weak amphitheater.... (分组背包 && 并查集)的相关文章

http://codeforces.com/contest/741/problem/B B. Arpa&#39;s weak amphitheater and Mehrdad&#39;s valuable Hoses

题意: 给出上限体重W 然后还给出每个人的体重wi 和 魅力值 bi 互为伙伴的对(xi, yi) 可以凑成group 思路: 并查集找出所有的group 暴力背包 对于每一个group 要选出这一组内选一个人时的最优结果, 如果所有人的体重和小于等于W,还得考虑选所有人的情况 #include <iostream> #include <string.h> #include <algorithm> #include <stdio.h> #include &l

D. Arpa&#39;s weak amphitheater and Mehrdad&#39;s valuable Hoses 分组背包模板题

http://codeforces.com/problemset/problem/742/D 并查集预处理出所有关系. 一开始的时候,我预处理所有关系后,然后选择全部的时候,另起了一个for,然后再判断. 这样是不对的.因为这样使得同一组里面可能选择了两次. 3 0 2 1 2 3 1 1 3 #include <cstdio> #include <cstdlib> #include <cstring> #include <cmath> #include &

Codeforces 741B Arpa&#39;s weak amphitheater and Mehrdad&#39;s valuable Hoses

[题目链接] http://codeforces.com/problemset/problem/741/B [题目大意] 给出一张图,所有连通块构成分组,每个点有价值和代价, 要么选择整个连通块,要么只能在连通块中选择一个,或者不选,为最大价值 [题解] 首先我们用并查集求出连通块,然后对连通块进行分组背包即可. [代码] #include <cstdio> #include <vector> #include <algorithm> #include <cstr

Arpa&#39;s weak amphitheater and Mehrdad&#39;s valuable Hoses CodeForces - 742D

Just to remind, girls in Arpa's land are really nice. Mehrdad wants to invite some Hoses to the palace for a dancing party. Each Hos has some weight wi and some beauty bi. Also each Hos may have some friends. Hoses are divided in some friendship grou

codeforces 742D Arpa&#39;s weak amphitheater and Mehrdad&#39;s valuable Hoses ——(01背包变形)

题意:给你若干个集合,每个集合内的物品要么选任意一个,要么所有都选,求最后在背包能容纳的范围下最大的价值. 分析:对于每个并查集,从上到下滚动维护即可,其实就是一个01背包= =. 代码如下: 1 #include <stdio.h> 2 #include <algorithm> 3 #include <string.h> 4 #include <vector> 5 using namespace std; 6 const int N = 1000 + 5;

并查集+背包 【CF741B】 Arpa&#39;s weak amphitheater and Mehrdad&#39;s valuable Hoses

Descirption 有n个人,每个人都有颜值bi与体重wi.剧场的容量为W.有m条关系,xi与yi表示xi和yi是好朋友,在一个小组. 每个小组要么全部参加舞会,要么参加人数不能超过1人. 问保证总重量不超过W,剧场中的颜值最大能到多少? Input 第一行,三个整数n,m,w 第二行,n个整数w1,w2,...,wn 第三行,n个整数b1,b2,...,bn 接下来m行,每行表示一个关系,第i行有两个整数xi和yi. 每一组朋友关系都是不同的. Output ?一行,表示最大的魅力值总和.

CF741B Arpa&#39;s weak amphitheater and Mehrdad&#39;s valuable Hoses 并查集 01背包

title CF741B 简化题意: 有 \(n\) 个人 \((1<=n<=1000)\) ,每个人有一个重量 \(w_i(1\leqslant w_i\leqslant 1000)\) 和一个魅力值 \(b_i(1\leqslant b_i\leqslant 10^6)\) . \(n\) 个人之间有 \(m(1\leqslant m\leqslant min(\frac{n(n-1)}{2}, 10^5))\) 个关系.第 \(i\) 个关系由两个数字 \(x_i\) 和 \(y_i\)

ZOJ Problem Set - 3321 并查集

题目链接:http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemCode=3321 Circle Time Limit: 1 Second      Memory Limit: 32768 KB Your task is so easy. I will give you an undirected graph, and you just need to tell me whether the graph is just a circle.

loj6157 A^B Problem (并查集)

题目: https://loj.ac/problem/6157 分析: 这种树上异或,一般是采用分位考虑,但是这题即使分位,也会发现非常不好处理 这里考虑维护一个点到其根的路径的异或值 用并查集去检测m个测试 若s和t不在一个并查集内: 挑出s的根f1,t的根f2,father[f1]=f2,并且发现w[f1]=c^w[s]^w[t] 若s和t在一个并查集内: 那么首先这个并查集内的所有点的w值都已经求过了,那么只要check一下c是否等于w[s]^w[t]即可 如果最后并查集数量多于一个,那么